#include "config.h"
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include <gtk/gtk.h>

#include <libgimp/gimp.h>
#include <libgimp/gimpui.h>
#include <libgimp/gimpimage_pdb.h>

#include "main.h"
#include "render.h"
#include "texturize.h"

#include "plugin-intl.h"

float difference(//Calcule la distance entre image_tab et patch_tab pour la zone remplie:
                 //(x_min,y_min) -> (x_max,y_max) dans image_tab
                 //(x_min,y_min)-posn -> (x_max,y_max)-posn dans patch_tab
  gint width_i, gint width_p,
  guchar * image, guchar * patch,
  gint posn_x, gint posn_y,
  gint x_min, gint y_min, gint x_max, gint y_max,
  gint channels,
  guchar ** rempli);

void
offset_optimal(//Voir texturize.h
    gint * resultat,
    guchar * image, guchar * patch,
    gint width_p, gint height_p, gint width_i, gint height_i,
    gint x_patch_pos_min, gint y_patch_pos_min, gint x_patch_pos_max, gint y_patch_pos_max,
    gint channels, guchar ** rempli)
{
	gint x_i, y_i;
  float best_difference = HUGE, tmp_difference;

	for(x_i=x_patch_pos_min; x_i<x_patch_pos_max; x_i++)
	{
		for(y_i=y_patch_pos_min; y_i<y_patch_pos_max; y_i++)
		{
			tmp_difference = difference(
        width_i, width_p,
        image, patch,
        x_i,y_i,
        int_max(0,x_i), int_max(0,y_i),
        int_min(x_i+width_p,width_i), int_min(y_i+height_p,height_i),
        channels, rempli);
			if(tmp_difference < best_difference)
			{
				best_difference = tmp_difference;
				resultat[0]=x_i; resultat[1]=y_i;
			}
		}
	}
	return;
}

float difference(
  gint width_i, gint width_p,
  guchar * image, guchar * patch,
  gint posn_x, gint posn_y,
  gint x_min, gint y_min, gint x_max, gint y_max,
  gint channels, guchar ** rempli)
{
	gint somme=0, zone=0, x_i, y_i, k;
  guchar *image_ptr, *patch_ptr;

  for(y_i=y_min; y_i<y_max; y_i++)
  {
    image_ptr = image + (y_i*width_i + x_min)*channels;
    patch_ptr = patch + ((y_i-posn_y)*width_p +x_min-posn_x)*channels;
    for(x_i=x_min; x_i<x_max; x_i++)
		{
      if (rempli[x_i][y_i])
			{
        for(k = 0 ; k < channels; k++)
				{
          somme += abs(*image_ptr++ - *patch_ptr++);
          zone ++;
        }
      }
      else
      {
        image_ptr += channels;
        patch_ptr += channels;
      }
    }
	}
	if (zone == 0) {printf("bug:zone=0\n"); exit(-1);}
	return(((float) somme) / ((float) zone));
}
